<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace Gtm\Repository;

use LMS\Tools\Conference\Repositories;

class Record extends Repositories\Record
{
    public function __construct($options)
    {
        parent::__construct($options);
    }

    /**
     * Returns record of conference specified by $sessioname
     *
     * @param string $sessionName
     * @return int mixed
     */
    public function getBySessionName($sessionName)
    {
        $query = "SELECT `rec`.*, rfile.filepath as filename FROM `#__lms_conference_records` `rec`
                    LEFT JOIN
                        #__lms_conference_record_files_gtm rfile
                        ON rfile.record_id = rec.id
                    WHERE session_name = '".$sessionName."' ";
        $this->db->setQuery($query);
        return $this->db->loadObject();
    }

    /**
     * @param $recordID
     * @param $filename
     * @return mixed
     */
    public function saveFile($recordID, $filename)
    {
        $query = "INSERT INTO
                        #__lms_conference_record_files_gtm
                        (record_id, filepath)
                    VALUES
                        ('".$recordID."', " . $this->db->quote($filename) . ")";
        $this->db->setQuery($query);
        return $this->db->query();
    }

	protected function beforeSave(&$data)
	{
		$data['course_id'] = $data['courseID'];
	}
}