<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$_JLMS_PLUGINS = & JLMSFactory::getPlugins();
$_JLMS_PLUGINS->registerFunction( 'onCourseJoin', 'notifyCourseJoined' );

function notifyCourseJoined( $users_info ) {
	$_JLMS_PLUGINS = & JLMSFactory::getPlugins();
	$JLMS_CONFIG = JLMSFactory::getConfig();

	if (!class_exists('JLMSParameters'))
	{
	if (JLMS_Jversion() == 2) {
			require_once(_JOOMLMS_FRONT_HOME . DS . "includes" . DS . "classes" . DS . "lms.params.new.php");
		} else {
			require_once(_JOOMLMS_FRONT_HOME . DS . "includes" . DS . "classes" . DS . "lms.params.php");
		}
	}
	
	//---->get bot info
	$dbo = & JLMSFactory::GetDb();
	if ( !isset($_JLMS_PLUGINS->_nontify_bot_params['coursejoinnotify']) ) {
		// load mambot params info
		$query = "SELECT params"
		. "\n FROM #__lms_plugins"
		. "\n WHERE element = 'coursejoinnotify'"
		. "\n AND folder = 'notifications'"
		;
		$dbo->setQuery( $query );
		$bot = $dbo->loadObject();

		// save query to class variable
		$_JLMS_PLUGINS->_notify_bot_params['coursejoinnotify'] = $bot;
	}

	// pull query data from class variable
	$bot = $_JLMS_PLUGINS->_notify_bot_params['coursejoinnotify'];

	$botParams = new jlmsPluginParameters( $bot->params );

	$mailTemplate = $botParams->get( 'mail_template', 'Hello {user_name}, You have just been added to the course {course_name} attendees list.' );
	$mailSubject = $botParams->get( 'mail_subject', 'Course joining notification' );
	//<----
	if (sizeof($users_info))
	foreach ($users_info as $info_ids) {
		$query = "SELECT c.course_name AS course_name, u.name AS user_name, u.email AS mail_address FROM #__lms_courses AS c, #__users AS u"
		."\n WHERE c.id=$info_ids->course_id AND u.id=$info_ids->user_id";
		$dbo->setQuery($query);
		$info_text = $dbo->loadObject();
		
		$mail_address = JLMSDatabaseHelper::GetEscaped($info_text->mail_address);
		
		$mail_subject = JLMSDatabaseHelper::GetEscaped($mailSubject);
		
		$mail_text = $mailTemplate;
		$mail_text = str_replace('{user_name}', $info_text->user_name, $mail_text);
		$mail_text = str_replace('{course_name}', $info_text->course_name, $mail_text);
		$mail_text = str_replace('{site_URL}', $JLMS_CONFIG->get('live_site'), $mail_text);
		$mail_text = JLMSDatabaseHelper::GetEscaped($mail_text);
		if (isset($info_ids->teacher_id))
		{
		$query = "INSERT INTO #__lms_notifications (assigned, mail_address, mail_subject, mail_body, sent) VALUES"
		."\n ($info_ids->teacher_id, '$mail_address', '$mail_subject', '$mail_text', 0)";
		$dbo->setQuery($query);
		$dbo->query();
		}
	}
}
?>