<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 *
 */

namespace LMS\Widgets;

use LMS\Libraries;
use LMS\Libraries\Base;

class PageTip extends Base\Widget
{		
	public function __construct($params = array())
	{	
		parent::__construct($params);
		
		$this->type = 'info';		
		$this->message = '';
		$this->center = true;
		if (!empty($params['page']) && $params['page']) {
			$page = $params['page'];
			$db = \JFactory::getDbo();
			$juser = \JFactory::getUser();
			if ($juser->get('id')) {
				//logged in user - ok
			} else {
				if($params['page'] == 'subscription' || $params['page'] == 'show_cart'){
					$page = $page.'_guest';
				}
			}
			$query = "SELECT tip_message FROM #__lms_page_tips WHERE tip_task = ".$db->quote($page);
			$db->SetQuery($query);
			$message = $db->LoadResult();
			if ($message) {
				$this->message = $message;
			}
		}
	}
}