<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 *
 */

namespace LMS\Widgets;

use LMS\Libraries;
use LMS\Libraries\Base;

class Tabs extends Base\Widget
{		
	public function __construct($params = array())
	{	
		parent::__construct($params);
		
		$this->tabs = (empty($params['tabs']))?array():$params['tabs'];
		
		if(!empty($params['script'])) {
			$this->addStyleSheet('/media/jui/css/bootstrap.css');
			$this->addScript('/media/jui/js/bootstrap.min.js');
			
			$this->setTemplate('script');
		}		
	}
	
	public function addTab($params = array())
	{		
		$this->tabs[] = $params;		
	}
}